function ConvertVideoIntoAniGIF(video, gif_filename, step)

    if (nargin < 3 || isempty(step))
        step = 1;
    end
    
    if (isfield(video, 'frames') && ~isempty(video.frames))
        num_frames = numel(video.frames);
    else
        num_frames = size(video.grayscale_frames, 3);
    end
    
    for i = 1:step:num_frames
        disp(['Processing frame ', num2str(i),' out of ', num2str(num_frames)]);
        
        if (isfield(video, 'frames') && ~isempty(video.frames))
            img = im2double(video.frames(i).cdata);
        else
            img = video.grayscale_frames(:,:,i);
            img = repmat(img, [1,1,3]);
        end
        
        [img, cmap] = rgb2ind(img, 256, 'nodither');
        
        if (i == 1)
            imwrite(img, cmap, gif_filename,'DelayTime',0,'LoopCount',inf);
        else
            imwrite(img, cmap, gif_filename,'DelayTime',0, 'WriteMode', 'append');
        end
    end
