function sol_video = CreateSolutionVideo(video, X, no_sups)

    if (~exist('no_sups', 'var') || isempty(no_sups))
        no_sups = false;
    end
    
    sol_video.width = video.width;
    sol_video.height = video.height;
%     sol_video.rate = video.rate;
    sol_video.times = video.times;
    num_frames = size(video.grayscale_frames, 3);
    sol_video.frames = repmat(struct('cdata', [], 'colormap', []), num_frames, 1);

    if (no_sups)
        solution = GenerateBinaryVideoOutOfSolution(video, X);
    end
    
    sup_idx = 1;
    for i = 1:num_frames
        disp(['Processing frame ', num2str(i),' out of ', num2str(num_frames)]);
        if (isfield(video, 'frames') && ~isempty(video.frames))
            img = im2double(video.frames(i).cdata);
        else
            img = video.grayscale_frames(:,:,i);
            img = repmat(img, [1,1,3]);
        end
        num_sups = max(max(video.superpixels(:,:,i)));

        if (no_sups)
            disp_img(:,:,1) = img.*(1-solution(:,:,i)) + solution(:,:,i);
        else
            if (strcmp(video.sup_type, 'turbopixels'))
                disp_img = DrawSuperpixelsFigure(img, video.superpixels(:,:,i), X(sup_idx:(sup_idx+num_sups-1)), [], video.adjmat{i}, video.boundary_pixels{i});
            end
            if (strcmp(video.sup_type, 'lattice'))
                disp_img = DrawSuperpixelsFigure(img, video.superpixels(:,:,i), X(sup_idx:(sup_idx+num_sups-1)));
            end
        end
        
        sol_video.frames(i).cdata = disp_img;
        sup_idx = sup_idx + num_sups;
    end    
    
    