function Xs = DetectAreaChange(video, Xs)

    % Remove all solutions below this change
    lowest_allowable_change = 0.01;
    
    % Add all the solutions differences about this change
    area_change_thresh = 0.05;
    
    num_solutions = size(Xs, 2);
    area = zeros(1, num_solutions);
    
    for i = 1:num_solutions
        area(i) = double(Xs(:,i))' * video.sup_area;
    end

    
    area_change = area(1:end-1) - area(2:end);
    area_change = area_change ./ area(1:end-1);
    
    large_change = find(area_change > area_change_thresh);
    Xs_new = Xs(:, large_change) - Xs(:, large_change + 1);
    
    Xs = [Xs(:, area_change > lowest_allowable_change), Xs_new];
    
    