% Given an image, a superpixel image and which sups are selected in the
% foreground, draw the foreground region.

function disp_img = DrawSuperpixelsFigure(img, sup_image, X, filename, adjmat, boundary_pixels)

    fg = SupValueImage_MEX(sup_image, double(X));

    if (exist('adjmat', 'var') && ~isempty(adjmat))
        X = double(X);
        adjmat_fg = adjmat .* (X*X');
        adjmat_bg = adjmat .* ((1-X)*(1-X)');
        [sup1, sup2] = find(tril(adjmat_fg));
        for i = 1:numel(sup1)
            fg(boundary_pixels{sup1(i), sup2(i)}) = 1;
        end
        [sup1, sup2] = find(tril(adjmat_bg));
        for i = 1:numel(sup1)
            fg(boundary_pixels{sup1(i), sup2(i)}) = 0;
        end
        
        boundaries = sup_image == 0;
    else
        boundaries = seg2bmap(sup_image);
    end
    
    img(repmat(fg, [1,1,size(img,3)]) == 0) = ...
        img(repmat(fg, [1,1,size(img,3)]) == 0).^0.3;
    
    
    disp_img = display_logical(im2double(display_logical(img, ...
        bwmorph(seg2bmap(fg),'dilate', 5), [1,0,0])),  bwmorph(boundaries,'dilate', 1), [0,1,0]);
    
    if (nargout == 0)
        imshow(disp_img);
    end
    
    if (exist('filename', 'var') && ~isempty(filename))
        imwrite(disp_img, filename, 'jpg');
    end