function solution = GenerateBinaryVideoOutOfSolution(video, X)

    solution = false(size(video.grayscale_frames));
    
    num_frames = size(video.grayscale_frames, 3);
    
    for i = 1:num_frames
        X_cur = X(video.sup_idx_range(i,1):video.sup_idx_range(i,2));

        fg = SupValueImage_MEX(video.superpixels(:,:,i), double(X_cur)) > 0.5;
        
        if (strcmp(video.sup_type, 'turbopixels'))
            fg_dil = bwmorph(fg, 'dilate', 1);
            boundaries = video.superpixels(:,:,i) == 0;
            fg(boundaries) = fg_dil(boundaries);
        end 
        
        solution(:,:,i) = fg;
    end