% X is a vector of superpixel selections. Its length equals the total
% number of superpixels in the video (summed over all the frames)
function PlayColorFramesObject(video, X, frames)

    if (nargin < 3 || isempty(frames))
        frames = 1:size(video.grayscale_frames,3);
    end
    
    sup_idx = video.sup_idx_range(frames(1), 1);
    for i = frames(:)'
%         disp(['Processing frame ', num2str(i),' out of ', num2str(num_frames)]);
%         img = video.grayscale_frames(:,:,i);
        img = im2double(video.frames(i).cdata);
        num_sups = max(max(video.superpixels(:,:,i)));
        
%         imshow(rgb_img);
        if (strcmp(video.sup_type, 'turbopixels'))
            DrawSuperpixelsFigure(img, video.superpixels(:,:,i), X(sup_idx:(sup_idx+num_sups-1)), [], video.adjmat{i}, video.boundary_pixels{i});
        end
        if (strcmp(video.sup_type, 'lattice'))
            DrawSuperpixelsFigure(img, video.superpixels(:,:,i), X(sup_idx:(sup_idx+num_sups-1)));
        end
        drawnow;
        sup_idx = sup_idx + num_sups;
%         pause;
%         pause(0.01);
    end