function PlayGrayscaleFrames(video, X)

    num_frames = size(video.grayscale_frames, 3);
    if (nargin < 2)
        X = false(num_frames, 1);
    end
    
    for i = 1:num_frames
        disp(['Processing frame ', num2str(i),' out of ', num2str(num_frames)]);
        img = video.grayscale_frames(:,:,i);
        rgb_img = zeros(size(img, 1), size(img, 2), 3);
        rgb_img(:,:,1) = img;
        if (~X(i))
            rgb_img(:,:,2) = img;
            rgb_img(:,:,3) = img;
        end
        
%         imshow(rgb_img);
        num_sups = max(max(video.superpixels(:,:,i)));
        if (strcmp(video.sup_type, 'turbopixels'))
            DrawSuperpixelsFigure(rgb_img, video.superpixels(:,:,i), ones(num_sups, 1), [], video.adjmat{i}, video.boundary_pixels{i});
        end
        if (strcmp(video.sup_type, 'lattice'))
            DrawSuperpixelsFigure(rgb_img, video.superpixels(:,:,i), ones(num_sups, 1));
        end
        
        pause(0.01);
    end