function video = PreprocessVideoPb(video)

    num_frames = size(video.grayscale_frames, 3);
    video.Pb_processed = zeros(size(video.Pb));
    
    for i = 1:num_frames
        disp(['Processing frame ', num2str(i),' out of ', num2str(num_frames)]);

        pb = video.Pb(:,:,i);
        
        lower_score = 0.02;
        higher_score = 0.05;
        thinned_score = hysthresh(pb, higher_score, lower_score);

        % Link the resulting branches into edges with a given minimum length
        min_edge_length = 10;
        edgelist = edgelink(thinned_score, min_edge_length);

        new_pb = zeros(size(pb));
        for e = 1:numel(edgelist)
            edge_idx = sub2ind(size(pb), edgelist{e}(:,1), edgelist{e}(:,2));
            mean_pb = mean(pb(edge_idx));
            new_pb(edge_idx) = mean_pb;
        end
        
        video.Pb_processed(:,:,i) = new_pb;
    end