function video = ReadImages(frame_dir, frame_prefix, extension)

    files = dir([frame_dir, frame_prefix, '*.', extension]);
    
    num_frames = numel(files);
    num_frames = num_frames / 3;
    img = im2double(imread([frame_dir, files(1).name]));
    video.width = size(img, 2);
    video.height = size(img, 1);
    video.grayscale_frames = zeros(video.height, video.width, num_frames);
    
    for i = 1:num_frames
        disp(['Read frame #', num2str(i)]);
        
%         img = im2double(imread([frame_dir, files(i).name]));
%         img = im2double(imread([frame_dir, frame_prefix, num2str(i-1), '.', extension]));
        img = im2double(imread([frame_dir, frame_prefix, num2strPad(i,3), '.', extension]));
%         fname = [seqParams.seqRoot seqParams.imPrefix num2strPad(frameNum,seqParams.padNum) '.ppm'];
        
        if (size(img, 3) == 3)
            img = rgb2gray(img);
        end
        
        video.grayscale_frames(:,:,i) = img;
    end
    
    fps = 15;
    video.times = linspace(0, num_frames/fps, num_frames);
    