% Make all the C/C++ MEX files
make

% Load a video

% This would read an AVI file (doesn't work on Linux)
% video = mmread('livingroom.avi');

% Load a video from a directory of frame images
% video = ReadImages(frame_dir, frame_prefix, extension);


% If the AVI read failed, load a saved version of the video
load('video_livingroom.mat');

% Display the video
implay(video.frames);

% Create a directory for intermediate results and solutions
results_dir = 'Results';
mkdir(results_dir);

% Compute spatiotemporal closure of a video, storing intermediate results
% in the given directory
Xs = SpatiotemporalClosure(video, [results_dir,'/video_livingroom_']);

% Display all solutions in an HTML page
solution_dir = [results_dir, '/', 'Solutions'];
DisplayAllSolutions(video, Xs, solution_dir);

% Play one of the solutions
PlayColorFramesObject(video, Xs(:,end-1));

% Generate a binary video out of one of the solutions and display it
% This is useful if you want to use the result of the spatiotemporal
% segmentation.
solution_video = GenerateBinaryVideoOutOfSolution(video, Xs(:, end-1));
implay(solution_video);
